/*
 * Copyright (c) 2010, Oracle. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * * Neither the name of Oracle nor the names of its contributors
 *   may be used to endorse or promote products derived from this software without
 *   specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
package examples;

import com.datecs.fiscalprinter.SDK.model.DatecsFiscalDevice;
import com.datecs.fiscalprinter.SDK.model.UserLayerV1.cmdReceipt;
import com.fazecast.jSerialComm.SerialPort;
import connectivity.PrinterConnectionFactory;
import connectivity.RS232Const;
import javax.swing.DefaultComboBoxModel;
import connectivity.PrinterConnection;
import connectivity.SerialPrinterConnector;

public class DatecsSDK_Tets extends javax.swing.JFrame {
     public DatecsFiscalDevice    myFiscalDevice;
    private PrinterConnection fdConnection;
    

    public DatecsSDK_Tets()
    {
        initComponents();
        portNameComboBox.setModel(new DefaultComboBoxModel(listPCSerialPort()));
        baudRateComboBox.setModel(new DefaultComboBoxModel(RS232Const.RS232_BAUD_RATE_VALUES));
    }

    private String[] listPCSerialPort()
    {
        SerialPort[] ports = SerialPort.getCommPorts();
        String[] RS232_PORTS_LIST = new String[ports.length];
        for (int i = 0; i < ports.length; ++i) {

            RS232_PORTS_LIST[i] = ports[i].getSystemPortName();
        }
        return RS232_PORTS_LIST;

    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        btnPrintNonFiscal = new javax.swing.JButton();
        portNameComboBox = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        baudRateComboBox = new javax.swing.JComboBox<>();
        btnConnect = new javax.swing.JButton();
        labDevice = new javax.swing.JLabel();
        labErrorMonitor = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Antenna");

        btnPrintNonFiscal.setText("Non Fiscal Test");
        btnPrintNonFiscal.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnPrintNonFiscalActionPerformed(evt);
            }
        });

        portNameComboBox.setName("portNameComboBox"); // NOI18N
        portNameComboBox.addPopupMenuListener(new javax.swing.event.PopupMenuListener()
        {
            public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt)
            {
            }
            public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt)
            {
            }
            public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt)
            {
                portNameComboBoxPopupMenuWillBecomeVisible(evt);
            }
        });

        jLabel1.setText(RS232Const.RS232_PORT_NAME_PROP_NAME);

        jLabel2.setText(RS232Const.RS232_BAUD_RATE_PROP_NAME);

        btnConnect.setText("Connect");
        btnConnect.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnConnectActionPerformed(evt);
            }
        });

        labDevice.setText("Device:");

        labErrorMonitor.setText("Error:");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .add(18, 18, 18)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(labDevice)
                                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnPrintNonFiscal, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnConnect, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(baudRateComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .add(272, 272, 272))))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(labErrorMonitor)
                            .add(layout.createSequentialGroup()
                                .add(jLabel1)
                                .add(18, 18, 18)
                                .add(portNameComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .add(272, 272, 272))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(16, 16, 16)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(portNameComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(baudRateComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(labDevice)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnConnect)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(btnPrintNonFiscal)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 138, Short.MAX_VALUE)
                .add(labErrorMonitor)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void portNameComboBoxPopupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt)//GEN-FIRST:event_portNameComboBoxPopupMenuWillBecomeVisible
    {//GEN-HEADEREND:event_portNameComboBoxPopupMenuWillBecomeVisible
        portNameComboBox.setModel(new DefaultComboBoxModel(listPCSerialPort()));
    }//GEN-LAST:event_portNameComboBoxPopupMenuWillBecomeVisible

    private void btnPrintNonFiscalActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnPrintNonFiscalActionPerformed
    {//GEN-HEADEREND:event_btnPrintNonFiscalActionPerformed
        cmdReceipt.FiscalReceipt fiscalReceipt = new cmdReceipt.FiscalReceipt();
        try {
                        if (!fiscalReceipt.isOpen()) {
                        //   () 
                        String operatorCode = "1";//    /1  16/
                        String operatorPassword = "0000"; //  /4  8 /
                        String salePoint = "1"; //    /   1  99999/
                        fiscalReceipt.openFiscalReceipt(operatorCode, operatorPassword, salePoint, "");
                        // ()  
                        cmdReceipt.FiscalReceipt.FiscalSale testSale =
                                new cmdReceipt.FiscalReceipt.FiscalSale();

                        testSale.add(
                                "",
                                " ",
                                "", //,...
                                "0.01", "1", "",
                                cmdReceipt.FiscalReceipt.FiscalSale.CorrectionType.noCorecction,
                                "");
                        cmdReceipt.TotalResult totalResult = testSale.saleTotal(
                                ":",
                                "",
                                cmdReceipt.FiscalReceipt.FiscalSale.PaidMode.fromOrdinal(0).getId(),
                                "");
                        fiscalReceipt.closeFiscalReceipt();
                    } else fiscalReceipt.cancel();

                     
        } catch (Exception ex) {
         labErrorMonitor.setText(ex.getMessage());
        }
    }//GEN-LAST:event_btnPrintNonFiscalActionPerformed

    private void btnConnectActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnConnectActionPerformed
    {//GEN-HEADEREND:event_btnConnectActionPerformed

        try {
           //Disconnect if device is connected
            if (myFiscalDevice != null) {
                myFiscalDevice=null;
                fdConnection.close();
                btnConnect.setText("Connect...");
                labDevice.setText("");
                return;
            }
            fdConnection = PrinterConnectionFactory.createInstance("RS232_DEVICE_BUS"); // new ..   
            fdConnection.setTimeout(100);
            fdConnection.setBaudRate(Integer.valueOf(baudRateComboBox.getSelectedItem().toString()));
            myFiscalDevice=fdConnection.open(portNameComboBox.getSelectedItem().toString());
            //TODO: is Connected
           if(myFiscalDevice.isConnectedPrinter())
             {
            labDevice.setText(SerialPrinterConnector.getModelName());
            btnConnect.setText("Disconnect...");
             }else labDevice.setText("Fiscal Device not detected..");

        } catch (Exception ex) {
            labErrorMonitor.setText(ex.getMessage());
                }

    }//GEN-LAST:event_btnConnectActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            javax.swing.UIManager.LookAndFeelInfo[] installedLookAndFeels = javax.swing.UIManager.getInstalledLookAndFeels();
            for (int idx = 0; idx < installedLookAndFeels.length; idx++) {
                if ("Nimbus".equals(installedLookAndFeels[idx].getName())) {
                    javax.swing.UIManager.setLookAndFeel(installedLookAndFeels[idx].getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DatecsSDK_Tets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DatecsSDK_Tets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DatecsSDK_Tets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DatecsSDK_Tets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run()
            {
                new DatecsSDK_Tets().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> baudRateComboBox;
    private javax.swing.JButton btnConnect;
    private javax.swing.JButton btnPrintNonFiscal;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel labDevice;
    private javax.swing.JLabel labErrorMonitor;
    private javax.swing.JComboBox<String> portNameComboBox;
    // End of variables declaration//GEN-END:variables

    private Object DatecsgetConnectedModel()
    {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

}
