/**
 * In this dialog, you can execute each command from the low level protocol of your fiscal drive.
 * Provides visualization of output data parsed by device delimiters.
 * The input data shall be filled in separately with the appropriate delimiter. [\t] - ASCII 0x09
 * The demonstration shows the use of the cmdService.customCommand method from the Datecs Java SDK.
 *
 * @author Datecs Ltd. Software Department
 *
 */

package com.datecs.demo.ui.main;

import android.app.Activity;
import android.app.Dialog;
import android.databinding.DataBindingUtil;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Toast;

import com.datecs.demo.CustomCmd_binding;
import com.datecs.fiscalprinter.SDK.model.UserLayerV1.cmdService;
import com.datecs.testApp.R;


public class DialogCustomCommand extends Dialog implements
        View.OnClickListener {


    public DialogCustomCommand(Activity a) {
        super(a, R.style.Dialog);
    }

    private CustomCmd_binding binder;
    private cmdService myCommand;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binder = DataBindingUtil.inflate(LayoutInflater.from(getContext()), R.layout.custom_cmd_dialog, null, false);
        try {

        } catch (Exception e) {

        }
        setContentView(binder.getRoot());
        binder.btnCustomCmdExec.setOnClickListener(this);
        binder.btnCustomCmdCancel.setOnClickListener(this);
        binder.btnCustomCmdTab.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btn_CustomCmdExec:
                try {
                    myCommand = new cmdService();
                    String[] cmdResult = myCommand.customCommand(binder.edCustCmdCmd.getText().toString(), binder.edCustCmdData.getText().toString());
                    binder.edCustCmdRes.setText("");
                    String resStr = "";
                    for (int i = 0; i < cmdResult.length; i++) {
                        resStr += cmdResult[i] + "\n";
                    }
                    binder.edCustCmdRes.setMaxLines(cmdResult.length);
                    binder.edCustCmdRes.setText(resStr);
                } catch (Exception e) {
                    Toast.makeText(getContext(), e.getMessage(), Toast.LENGTH_SHORT).show();
                    e.printStackTrace();
                }
                break;
            case R.id.btn_CustomCmdTab:
                String s = binder.edCustCmdData.getText().toString();

                ////String s1 = s.substring(0, binder.edCustCmdData.getSelectionStart()) + "\t" + s.substring(binder.edCustCmdData.getSelectionStart(), s.length());
                binder.edCustCmdData.setText(binder.edCustCmdData.getText().insert(binder.edCustCmdData.getSelectionStart(),"\t"));


                break;

            case R.id.btn_CustomCmdCancel:
                dismiss();
                break;
            default:
                break;
        }

    }


}


